void VDraw(short x, short y, const char *string);
void DDraw(short x0, short y0, short x1, short y1, const char *string);
void carre(short x1, short y1, short mode);
void Bezier(int X00,int Y00,int X01,int Y01,int X02,int Y02,int X03,int Y03, short mode);
void Cercle(short ctrx, short ctry, short rayon);

// UTILITAIRES NON-PARTIE GRAPHIQUE ////////////////////////////////////
void carre(short x1, short y1, short mode);
void DrawClose(short x_long, short y_start);
void DrawCross(short x, short y);
void ErsSprite(short x, short y);
void draw_rect_select(short x_init, short y_init, short x, short y, short mode);
void DrawTxtPnt(short x, short y);
void ErsTxtPnt(short x, short y);
void DrawCercle(short x, short y);
void DrawCercle_ers(short x, short y);


void carre(short x1, short y1, short mode)
{
	short i,j;
	short x2 = x1+3, y2 = y1+3;
	
	for (i=x1;i<x2+1;i++)
	  for (j=y1;j<y2+1;j++)
	{
		if (mode)
		{
			if (i == x1 || i == x2 || j == y1 || j == y2)
				PutPxl(i,j);
			else
				ErsPxl(i,j);		
		}
		else
				ErsPxl(i,j);
	}
}


void DrawClose(short x_long, short y_start)
// compter l'arrondi de -1 pxl
{
	short i,j;
	for (i=x_long;i>x_long-6;i--)
	for (j=y_start;j<y_start+6;j++)
		{
			if ((j%5 == i%5) || (j%5 == (5-i%5)))
				ErsPxl(i,j);
			else
				PutPxl(i,j);
		}
}

void DrawCercle(short x, short y){
	Sprite8 (x, y, 8, cercle, LCD_MEM, SPRT_OR);
}

void DrawCross(short x, short y)
{
	Sprite8 (x, y, 8, pmask, LCD_MEM, SPRT_AND);
  Sprite8 (x, y, 8, pointeur, LCD_MEM, SPRT_OR);
}

/*
void DrawPen(short x, short y)
{
	Sprite8 (x, y, 8, pmask, LCD_MEM, SPRT_AND);
	Sprite8 (x, y, 8, Pen_Left_Up, LCD_MEM, SPRT_OR);
}
*/

void ErsSprite(short x, short y)
{
	Sprite8 (x, y, 8, pmask, LCD_MEM, SPRT_AND);
}

void draw_rect_select(short x_init, short y_init, short x, short y, short mode)
{
		carre(x_init,y_init,mode); carre(x,y,mode);
		carre(x_init,y,mode);      carre(x,y_init,mode); 	

	x_init+=1; y_init+=1; x+=1; y+=1;
	
	DrawLine(x_init,y_init,x,y_init,A_NORMAL); 
	DrawLine(x_init,y,x,y,A_NORMAL); 
	DrawLine(x_init,y_init,x_init,y,A_NORMAL); 
	DrawLine(x,y_init,x,y,A_NORMAL);	
		
}


void DrawTxtPnt(short x, short y)
{
	Sprite8 (x, y, 8, pmask, LCD_MEM, SPRT_AND);
  Sprite8 (x, y, 8, txt_pnt, LCD_MEM, SPRT_OR);
}

void ErsTxtPnt(short x, short y)
{
	Sprite8 (x, y, 8, pmask, LCD_MEM, SPRT_AND);
}


////////////////////////////////////////////////////////////////////////


void VDraw(short x, short y, const char *string)
{
	if (strlen(string)*7 > (unsigned short)(ymax-25)) return;
	else
	{
	DrawStatus_OO("Texte vertical en cours ...");
	y-=7;
	while(*string)
	{
		DrawChar(x,y+=7,*string++,A_NORMAL);
	}
	DrawStatus_OO("Texte vertical fini !");
 }
}

void DDraw(short x0, short y0, short x1, short y1, const char *string)
{
	if 			(x0 == x1)
		VDraw(x0,y0,string);
	else if (y0 == y1)
		DrawStr(x0,y0,string,A_NORMAL);
	else
	{
		DrawStatus_OO("Texte diagonal en cours ...");
		short x_delta = (x1 - x0);
		short y_delta = (y1 - y0);
		short x_start = min(x1,x0);
		short y_start = min(y1,y0);
	  x_delta/=(strlen(string));
		y_delta/=(strlen(string));

		x_start -= x_delta;
		y_start -= y_delta;

		while(*string)
		{
			DrawChar(x_start+=x_delta,y_start+=y_delta,*string++,A_NORMAL);
		}
		DrawStatus_OO("Texte diagonal fini !");
	}	
}


void Bezier(int X00,int Y00,int X01,int Y01,int X02,int Y02,int X03,int Y03, short mode)
// fonction de trac de courbes de beziers sur 3 points
// n = nombre de points calculs
{
	DrawStatus_OO("Courbe de Bezier en cours ...");
	
	float A1,B1,C1,D1;
	float A2,B2,C2,D2;
	float f,fsqr,fcube;
	
	float x,dx,ddx,dddx, y,dy,ddy,dddy;

	// calcul de nombre d'itration  faire ... (par droites + erreur)
	// perso alatoire ;)))

	unsigned short n;	
	unsigned short nombre1=0, nombre2=0,nombre3=0,erreur=0;
	
	nombre1 = (unsigned short)ceil(max(X00,X01)/min(X00,X01)*(abs(Y01-Y00)));
	nombre2 = (unsigned short)ceil(max(X01,X02)/min(X01,X02)*(abs(Y02-Y01)));
	nombre3 = (unsigned short)ceil(max(X02,X03)/min(X02,X03)*(abs(Y03-Y02)));
	erreur  = (unsigned short)ceil(max(X00,X03)/min(X00,X03)*(abs(Y03-Y00)));

  n = (nombre1 + nombre2 + nombre3 + erreur)<<2;

	// polynome de bernstein, degr 3

  A1 = (X03 - 3.0 * X02 + 3.0 * X01 - X00);
  B1 = (3.0 * X02 - 6.0 * X01 + 3.0 * X00);
  C1 = (3.0 * X01 - 3.0 * X00);
  D1 = X00;

  A2  = (Y03  - 3.0 * Y02  + 3.0 * Y01  - Y00 );
  B2  = (3.0 * Y02  - 6.0 * Y01  + 3.0 * Y00 );
  C2  = (3.0 * Y01  - 3.0 * Y00 );
  D2  = Y00 ;
 
f = 1.0 / (float)n; 
fsqr = f * f;
fcube = f * fsqr;

		// les diverses drives ...
		
	   x = D1 ;
	  dx = A1  * fcube + B1  * fsqr + C1  * f;
	dddx = 6.0 * A1  * fcube;
	 ddx = dddx + 2.0 * B1  * fsqr;
	   y = D2 ;
	  dy = A2  * fcube + B2  * fsqr + C2  * f;
	dddy = 6.0 * A2  * fcube;
	 ddy = dddy + 2.0 * B2  * fsqr;

	while(n--)
	{
	   (mode ? PutPxl(x,y) : ErsPxl(x,y));
      x += dx; 
     dx += ddx;
    ddx += dddx;
      y += dy;
     dy += ddy;
    ddy += dddy;
   }		
  
  DrawStatus_OO("Courbe de Bezier finie !");
}


void Cercle(short ctrx, short ctry, short rayon)
{
   short chgmt, xx, yy,zz;
   xx = 0;
   yy = rayon;
   zz = 0;
   chgmt = -rayon;

   do {

     PutPxl(ctrx+xx, ctry+yy);
     PutPxl(ctrx-xx, ctry+yy);
     PutPxl(ctrx-xx, ctry-yy);
     PutPxl(ctrx+xx, ctry-yy);
     PutPxl(ctrx+yy, ctry+xx);
     PutPxl(ctrx-yy, ctry+xx);
     PutPxl(ctrx-yy, ctry-xx);
     PutPxl(ctrx+yy, ctry-xx);

     if ((chgmt += xx++ + xx) >= 0)
     {
      zz = yy--;
      chgmt -= zz + yy;
     }

   }while (xx <= yy);
}

void Cercle_ers(short ctrx, short ctry, short rayon)
{
   short chgmt, xx, yy,zz;
   xx = 0;
   yy = rayon;
   zz = 0;
   chgmt = -rayon;

   do {

     ErsPxl(ctrx+xx, ctry+yy);
     ErsPxl(ctrx-xx, ctry+yy);
     ErsPxl(ctrx-xx, ctry-yy);
     ErsPxl(ctrx+xx, ctry-yy);
     ErsPxl(ctrx+yy, ctry+xx);
     ErsPxl(ctrx-yy, ctry+xx);
     ErsPxl(ctrx-yy, ctry-xx);
     ErsPxl(ctrx+yy, ctry-xx);

     if ((chgmt += xx++ + xx) >= 0)
     {
      zz = yy--;
      chgmt -= zz + yy;
     }

   }while (xx <= yy);
}

