// C Header File
// Created 19/10/2001; 14:30:13

#define _D0 asm("d0")
#define _D1 asm("d1")
#define _D2 asm("d2")
#define _D3 asm("d3")
#define _D4 asm("d4")
#define _A0 asm("a0")
#define _A1 asm("a1")


// partie graphique en assembleur
// powered by TinyX [XTeam -- http://xlib.kouette.com]
extern void PutPxl(short x _D0, short y _D1);
extern void ErsPxl(short x _D0, short y _D1);
extern void ChgPxl(short x _D0, short y _D1);
extern void fVLine(short x _D0);
extern void fHLine(short y _D0);
extern void fHLine_ers(short y _D0);
extern void tX_VLine(short y1 _D0, short y2 _D1, short x _D2, short etat _D4);
extern void Copy_scr(void* source _A1, void* destination _A0);

// utilitaires graphiques .. sauvegarde a la vole etc.
#define CornerErs(x1,y1,x2,y2) {ErsPxl(x2,y2); ErsPxl(x1,y1); ErsPxl(x1,y2); ErsPxl(x2,y1);}

// Fonction annuler ...
#define SaveBeforeAction() Copy_scr(LCD_MEM,lcd_sav)
#define RestoreByAnnul()   Copy_scr(lcd_sav,LCD_MEM)

// Savegarde tres rapide ...
#define SaveActualScr() 	Copy_scr(LCD_MEM,dessin)
#define RestoreOldScr() 	Copy_scr(dessin,LCD_MEM)

#define Prelance() 		{short prout; for(prout=10;prout<(ymax-10);prout++) fHLine_ers(prout);}
#define UseGoodFont() {if(FontGetSys() != F_4x6) FontSetSys(F_4x6);}


// partie graphique, gestion du menu & others ...
void  DrawStatus_OO(const char *status_txt);
void  LoadInterface(void);
void  DrawRect(short x1, short y1, short x2, short y2);
short ShowLayer1(void);
short ShowLayer2(void);
short ShowLayer3(void);
short ShowLayer4(void);
void  BoucleMenu(void);


void DrawStatus_OO(const char *status_txt)
{
	short i;
	for (i=ymax;i>ymax-10;i--) fHLine_ers(i);
	DrawRect(1, ymax-9, xmax-2, ymax-1);
	FontSetSys(F_4x6);
	DrawStr(2,ymax-7,status_txt,A_NORMAL);	
}

void DrawRect(short x1, short y1, short x2, short y2)
{
	short i;
	for (i=x1;i<x2;i++)
		tX_VLine(y1,y2,i,0);

	DrawLine(x1,y1,x2,y1,A_NORMAL); 
	DrawLine(x1,y2,x2,y2,A_NORMAL); 
	DrawLine(x1,y1,x1,y2,A_NORMAL); 
	DrawLine(x2,y1,x2,y2,A_NORMAL);	
	CornerErs(x1,y1,x2,y2);
}


void LoadInterface(void)
{
	FontSetSys(F_4x6);
	
	DrawRect(1, ymax-9, xmax-2, ymax-1);
	DrawRect(1, 0, xmax-2, 8);
	DrawStr(2,2,barre_menu, A_NORMAL);
	DrawStr(2,ymax-7,version,A_NORMAL);
}

short ShowLayer1(void)
{
	short a=0,i;

	DrawStatus_OO(str_menu1);
	DrawRect(2,9,5+DrawStrWidth(Layer1[2],F_4x6),7*8+1);
	
	for (i=0;i<6;i++)
	{
			if (i == 5) DrawStr(3,11+8*i,Layer1[i],A_SHADED);
			else
									DrawStr(3,11+8*i,Layer1[i],A_NORMAL);
	}
	
	while(!a)
	{
		if      (_keytest(RR_1))  	a=11;
		else if (_keytest(RR_2))  	a=12;
		else if (_keytest(RR_3))  	a=13;
		else if (_keytest(RR_4))  	a=14;
		else if (_keytest(RR_5))  	a=15;
		else if ((_keytest(RR_6)) || (_keytest(RR_ALPHA) && _keytest(RR_Z)) )  	a=16;		
		
		else if (_keytest(RR_F3)) 	a=333;
		else if (_keytest(RR_F2)) 	a=222;
		else if (_keytest(RR_F4)) 	a=444;
		else if (_keytest(RR_ESC)) 	{a=999; break;}	
		else												a=0;
	}
	return a;	
}


short ShowLayer2(void)
{
	short a=0,i;
	DrawRect(40,9,40+3+DrawStrWidth(Layer2[3],F_4x6),11*8+1);
	for (i=0;i<10;i++){
	   if (i >= 8)  DrawStr(40+1,11+8*i,Layer2[i],A_SHADED);
		 else 				DrawStr(40+1,11+8*i,Layer2[i],A_NORMAL);
	}
	DrawStatus_OO(str_menu2);
	while(!a)
	{
		if 			(_keytest(RR_1)) 		a=21;
		else if (_keytest(RR_2)) 		a=22;
		else if (_keytest(RR_3)) 		a=23;
		else if (_keytest(RR_4)) 		a=24;
		else if (_keytest(RR_5)) 		a=25;
		else if (_keytest(RR_6)) 		a=26;
		else if (_keytest(RR_7)) 		a=27;
		else if (_keytest(RR_8)) 		a=28;
		//else if (_keytest(RR_9)) 		a=29;	
		//else if (_keytest(RR_0)) 		a=20;	
		
		else if (_keytest(RR_F1)) 	a=111;
		else if (_keytest(RR_F3)) 	a=333;
		else if (_keytest(RR_F4)) 	a=444;
		else if (_keytest(RR_ESC)) 	{a=999; break;}
	  else												a=0;
	}
	return a;	
}


short ShowLayer3(void)
{
	short a=0,i;
	DrawRect(85,9,85+3+DrawStrWidth(Layer3[0],F_4x6),6*8+1);
	for (i=0;i<5;i++)
	{
	  if (i >= 3) DrawStr(86,11+8*i,Layer3[i],A_SHADED);
	  else    		DrawStr(86,11+8*i,Layer3[i],A_NORMAL);
	}
	
	DrawStatus_OO(str_menu3);
	while(!a)
	{
		if 			(_keytest(RR_1)) 		a=31;
		else if (_keytest(RR_2)) 		a=32;
		else if (_keytest(RR_3)) 		a=33;
		//else if (_keytest(RR_4)) 		a=34;
		//else if (_keytest(RR_5)) 		a=35;
		else if (_keytest(RR_F4)) 	a=444;
		else if (_keytest(RR_F2)) 	a=222;
		else if (_keytest(RR_F1)) 	a=111;
		else if (_keytest(RR_ESC)) 	{a=999; break;}
		else												a=0;
	}
	return a;	
}

short ShowLayer4(void)
{
	short a=0,i;
	DrawRect(115,9,118+DrawStrWidth(Layer4[1],F_4x6),4*8+1);
	for (i=0;i<3;i++)
		DrawStr(116,11+8*i,Layer4[i],A_NORMAL);
	
	DrawStatus_OO(str_menu4);
	while(!a)
	{
		if 			(_keytest(RR_1)) 		a=41;
		else if (_keytest(RR_2)) 		a=42;
		else if (_keytest(RR_3)) 		a=43;
		else if (_keytest(RR_F3)) 	a=333;
		else if (_keytest(RR_F2)) 	a=222;
		else if (_keytest(RR_F1)) 	a=111;
		else if (_keytest(RR_ESC)) 	{a=999; break;}
		else												a=0;
	}
	return a;	
}


#include "touches.h"
#include "graphismes.h"  // affichage de sprites, Bezier, VDraw
#include "utilitaires.h" // utilitaires InputStr, InputPrettyPrint etc.
#include "utils_vat.h"   // vat, ouvrire image, sauver image
//#include "compress.h"    // Compression par ZipLib si kernel et KOMP sinon !
#include "actions.h"     // actions -> tous les appels ci-dessous


void BoucleMenu(void)
{
	short action=0;
	short sortie = 0;
	BOOL annuler=0;
	do
	{
		if (_keytest(RR_SHIFT) && _keytest(RR_ESC))	sortie = 1;
		if (_keytest(RR_SHIFT) && _keytest(RR_F1))	{SaveActualScr(); SaveBeforeAction(); sauvegarder(); RestoreOldScr(); action=0; DrawStatus_OO(version);}
		if (_keytest(RR_ALPHA) && _keytest(RR_Z))   {if (!annuler) {annuler=1;} else {annuler = 0;} DrawStatus_OO("Annulation ..."); action = 0;}
		
		if (_keytest(RR_F1))  {SaveActualScr(); SaveBeforeAction(); action = ShowLayer1(); RestoreOldScr(); DrawStatus_OO(version);}
		if (_keytest(RR_F2))  {SaveActualScr(); SaveBeforeAction(); action = ShowLayer2(); RestoreOldScr(); DrawStatus_OO(version);}
		if (_keytest(RR_F3))  {SaveActualScr(); SaveBeforeAction(); action = ShowLayer3(); RestoreOldScr(); DrawStatus_OO(version);}
		if (_keytest(RR_F4))  {SaveActualScr(); SaveBeforeAction(); action = ShowLayer4(); RestoreOldScr(); DrawStatus_OO(version);}
		
		
		if (action == 111) {SaveActualScr(); SaveBeforeAction(); action = ShowLayer1(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 222) {SaveActualScr(); SaveBeforeAction(); action = ShowLayer2(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 333) {SaveActualScr(); SaveBeforeAction(); action = ShowLayer3(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 444) {SaveActualScr(); SaveBeforeAction(); action = ShowLayer4(); RestoreOldScr(); DrawStatus_OO(version);}


		// serie du menu 4
		if (action == 41)		{SaveActualScr(); SaveBeforeAction(); aide(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 42)		{SaveActualScr(); SaveBeforeAction(); a_propos(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 43)		{SaveActualScr(); SaveBeforeAction(); contact(); RestoreOldScr(); DrawStatus_OO(version);}
		
		// serie de menu 1
		if (action == 11)   {SaveActualScr(); nouveau(); DrawStatus_OO(version);}
		if (action == 12)   {SaveActualScr(); SaveBeforeAction(); ouvrir(); DrawStatus_OO(version);}
		if (action == 13)   {SaveActualScr(); SaveBeforeAction(); sauvegarder(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 14)   {sortie = 1;}
		if (action == 15)   {SaveActualScr(); SaveBeforeAction(); pp_version(); RestoreOldScr(); DrawStatus_OO(version);}
		if (action == 16)		{if (!annuler) {annuler=1;} else {annuler = 0;} DrawStatus_OO("Annulation ..."); action = 0;}

		//serie de menu 2, le menu !!!
		if (action == 21)   {SaveActualScr(); SaveBeforeAction(); prettyprint(); DrawStatus_OO(version); }
		if (action == 22)   {SaveActualScr(); SaveBeforeAction(); vecteur(); DrawStatus_OO(version);}
		if (action == 23)   {SaveActualScr(); SaveBeforeAction(); txt_vert(); DrawStatus_OO(version);}
		if (action == 24)   {SaveActualScr(); SaveBeforeAction(); txt_horiz(); DrawStatus_OO(version);}
		if (action == 25)   {SaveActualScr(); SaveBeforeAction(); txt_diag(); DrawStatus_OO(version);}
		if (action == 26)		{SaveActualScr(); SaveBeforeAction(); bezier(); DrawStatus_OO(version);}
		if (action == 27)   {SaveActualScr(); SaveBeforeAction(); ellipse(); DrawStatus_OO(version);}
		if (action == 28)   {SaveActualScr(); SaveBeforeAction(); droite(); DrawStatus_OO(version);}

		// serie du menu 3
		if (action == 31)		{SaveBeforeAction(); tout_effacer();  DrawStatus_OO(version);}
		if (action == 32)		{SaveBeforeAction(); inverser(); DrawStatus_OO(version);}
		if (action == 33)		{SaveBeforeAction(); encadrer(); DrawStatus_OO(version);}
	  
		if (annuler)
		{
			Idle();
			RestoreByAnnul();
			annuler = 0;
		}

		action = 0;
	
	} while (!sortie);
	
}